<template>
    <Page>
        <ActionBar class="header">
            <StackLayout>
                <FlexboxLayout
                    flexDirection="row"
                    justifyContent="space-between" class="navbar"
                >
                    <Image
                        src="~/assets/images/menu.png"
                        class="menu"
                        stretch="fill"
                        @tap="$refs.drawer.nativeView.showDrawer()"
                    ></Image>
                    <Image
                        src="~/assets/images/logo.png"
                        class="logo"
                        stretch="fill"
                    ></Image>
                    <Image
                        src="~/assets/images/cloche.png"
                        class="bell"
                        stretch="fill"
                    ></Image>
                </FlexboxLayout>
            </StackLayout>
        </ActionBar>

        <RadSideDrawer ref="drawer">
            <StackLayout ~drawerContent backgroundColor="#ffffff">
                <DrawerContent/>
            </StackLayout>

            <StackLayout ~mainContent>
                <FlexboxLayout alignItems="center" class="back-button">
                    <Image src="~/assets/images/back.png" class="icon-margin" stretch="fill"></Image>
                    <Label class="back" text="Retour" @tap="$navigateBack"/>
                </FlexboxLayout>

                <ScrollView orientation="vertical">
                    <FlexboxLayout flexDirection="column" class="full-height">
                        <Label class="title">Réserver un logement</Label>
                        <Label class="info">Récapitulatif du logement :</Label>

                        <FlexboxLayout flexDirection="row" class="annonce">
                            <Image
                                src="~/assets/images/maison.png"
                                class="img-annonce"
                                stretch="fill"
                            ></Image>
                            <FlexboxLayout flexDirection="column" class="annonce-content">
                                <Label class="titre-annonce" :text="listOfItems.adv_name"/>
                                <Label class="address-annonce"
                                       :text="listOfItems.adv_adress + ', ' + listOfItems.adv_postal + ' ' + listOfItems.adv_city"/>
                                <Label class="nbCrit-annonce"
                                       :text="'Nombre de personnes : ' + listOfItems.adv_tenants"/>
                                <Label class="reserv-annonce" :text="'Prix : ' + listOfItems.adv_price + ' €/jour'"/>
                            </FlexboxLayout>
                        </FlexboxLayout>

                        <Label class="info">Réservation :</Label>

                        <FlexboxLayout flexDirection="row" class="dates">
                            <FlexboxLayout flexDirection="column" class="date">
                                <Label text="Date de début"/>
                                <Label :text="dateSelected.dateStart"/>
                            </FlexboxLayout>
                            <FlexboxLayout flexDirection="column" class="date">
                                <Label text="Date de fin"/>
                                <Label :text="dateSelected.dateEnd"/>
                            </FlexboxLayout>
                        </FlexboxLayout>

                        <Button text="Selectionner des dates" @tap="showModal()"/>

                        <FlexboxLayout flexDirection="row" class="">
                            <Label class="recap" text="Nombre de personne présente :"/>
                            <TextField
                                v-model="nbTenant"
                                :hint="listOfItems.adv_cri_limit"
                                keyboardType="number"
                                class="form-input"
                            />
                        </FlexboxLayout>

                        <Label class="recap" :text="'Nombre de jours total : ' + this.nbCount"/>
                        <Label class="recap" :text="'Prix total : ' + this.totalPrice + '€'"/>

                        <creditCardView id="card"></creditCardView>

                        <Button text="Réserver" @tap="reserv()"/>

                    </FlexboxLayout>
                </ScrollView>
            </StackLayout>
        </RadSideDrawer>
    </Page>
</template>

<script>
import {Http} from "@nativescript/core";
import DatePicker from "./DatePicker";
import DrawerContent from "./DrawerContent";
import {Couchbase} from 'nativescript-couchbase-plugin';

const database = new Couchbase('atp_base');

export default {
    props: ['idAdvert'],
    components: {
        DrawerContent,
    },
    data() {
        return {
            listOfItems: {},
            dateSelected: {},
            nbTenant: "",
            errorNbTenants: false,
            nbCount: "",
            totalPrice: "",
            response: "",
            user: {},
        }
    },
    mounted() {
        let db = database.query({select: []})
        this.user = db[0].userStore
        this.getAdvert()
    },
    methods: {
        showModal() {
            this.$showModal(DatePicker).then(() => {
                this.dateSelected = this.$store.getters["dates"];
                const diffDays = (date, otherDate) => Math.ceil(Math.abs(date - otherDate) / (1000 * 60 * 60 * 24));
                this.nbCount = diffDays(new Date(this.dateSelected.dateEnd), new Date(this.dateSelected.dateStart))
                this.calculPrice();
            });
        },
        calculPrice() {
            this.totalPrice = this.listOfItems.adv_price * this.nbCount;
        },
        onChangeTenantsFields() {
            if (this.nbTenant > this.listOfItems.adv_tenants) {
                alert("nombre de locataire supérieur à la capacité")
                this.errorNbTenants = true;
            } else {
                this.errorNbTenants = false;
            }
        },
        async getAdvert() {
            const response = await Http.request({
                url: "https://api.atypikhouse.art/getAdvertbyId",
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Access-Control-Allow-Origin": "*",
                },
                content: JSON.stringify({
                    adv_id: this.idAdvert
                }),
            })
            var result = response.content.toJSON();
            this.listOfItems = result.selectedAdvert[0];
        },
        async reserv() {
            this.onChangeTenantsFields();
            if (this.errorNbTenants === false) {
                const response = await Http.request({
                    url: "https://api.atypikhouse.art/createReserve",
                    method: "POST",
                    headers: {
                        "Content-Type": "application/json",
                        "Access-Control-Allow-Origin": "*",
                    },
                    content: JSON.stringify({
                        res_usr_id: this.user.usr_id,
                        res_adv_id: this.listOfItems.adv_id,
                        res_adv_name: this.listOfItems.adv_name,
                        res_date_start: this.dateSelected.dateStart,
                        res_date_end: this.dateSelected.dateEnd,
                        res_adv_price: this.listOfItems.adv_price,
                        res_adv_tenants: this.nbTenant,
                        res_usr_mail: this.user.usr_mail,
                        res_usr_phone: this.user.usr_phone
                    }),
                })
                var result = response.content.toJSON();
                if (result.succes) {
                    this.response = result.succes;
                } else {
                    this.response = result.Erreur || result.error;
                }
                alert(this.response)
            }
        },
    }
}
</script>

<style scoped>
.header {
    background-image: url("~/assets/images/header.png");
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center;
    width: 100%;
}

.navbar {
    height: 120;
    width: 100%;
    padding-top: 30;
}

.menu {
    text-align: left;
    width: 40;
    margin-top: 13vh;
    margin-bottom: 40vh;
}

.logo {
    width: 70;
    height: 90px;
    margin-bottom: 20vh;
    justify-self: center;
}

.bell {
    text-align: right;
    width: 40vw;
    margin-top: 13vh;
    margin-bottom: 40vh;
    margin-right: 10;
}

.back-button {
    margin-left: 10;
    margin-top: 10;
}

.back {
    text-align: left;
    color: #2d2d2d;
}

.icon-margin {
    margin-right: 10;
    width: 16;
    height: 16;
}

.full-height {
    height: max-content;
    margin-left: 20vw;
    margin-right: 20vw;
    margin-bottom: 50vh;
}

.title {
    text-align: center;
    font-size: 25px;
    color: #2d2d2d;
    margin-bottom: 10;
    margin-top: 10;
}

.info {
    text-align: center;
    font-size: 22px;
    color: #2d2d2d;
    margin: 0 20;
}

.recap {
    text-align: left;
    font-size: 20px;
    color: #2d2d2d;
    margin-bottom: 10;
    margin-top: 10;
}

.annonce {
    padding-top: 10;
    padding-bottom: 10;
    border-bottom-color: #7d7d7d;
    border-bottom-width: 2;
}

.img-annonce {
    width: 80;
    height: 80;
    margin-right: 20;
}

.titre-annonce {
    font-size: 16px;
    color: #2d2d2d;
}

.address-annonce {
    font-size: 14px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
}

.nbCrit-annonce {
    font-size: 14px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
}

.reserv-annonce {
    font-size: 14px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
}

.dates {
    width: 100%;
    margin: 10;
}

.date {
    width: 50%;
    text-align: center;
    font-size: 16px;
    color: #2d2d2d;
}

.icon-margin {
    margin-right: 10;
    width: 16;
    height: 16;
}

.form-input {
    width: 50;
    margin-left: 10;
}
</style>
